public class Witch {
	private static int totalWitches = 0;

	private String name;
	private String school;
	private int magicPower;

	final int MAX_LEVEL = 100;
	final int MIN_LEVEL = 0;

	// Constructors
	public Witch() {
		this.name = "no one";
		this.school = "unknown school";
		this.magicPower = 10;
		Witch.totalWitches++;
	}

	public Witch(String name, String school, int magicPower) {
		this.name = name;
		this.school = school;
		this.magicPower = magicPower;
		Witch.totalWitches++;
	}

	public Witch(Witch w) {
		this.magicPower = w.getMagicPower();
		this.name = w.getName();
		this.school = w.getSchool();
		Witch.totalWitches++;
	}

	// Getters
	public static int getTotalWitches() {
		return Witch.totalWitches;
	}

	public String getName() {
		return this.name;
	}

	public int getMagicPower() {
		return this.magicPower;
	}

	public String getSchool() {
		return this.school;
	}

	// Setters
	public static void setTotalWitches(int totalWitches) {
		Witch.totalWitches = totalWitches;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setMagicPower(int magicPower) {
		if (magicPower < MIN_LEVEL)
			magicPower = MIN_LEVEL;
		if (magicPower > MAX_LEVEL)
			magicPower = MAX_LEVEL;
		this.magicPower = magicPower;
	}

	public void setSchool(String school) {
		this.school = school;
	}

	// Utilities
	public String toString() {
		return String.format("Witchname: %s, School: %s, Magic Power: %s", this.name, this.school, this.magicPower);
	}

	public int compareTo(Witch w) {
		if (this.magicPower > w.magicPower)
			return 1;
		else if (this.magicPower == w.magicPower)
			return 0;
		else if (this.magicPower < w.magicPower)
			return -1;
		return 9999; // This statement should not be called
	}

	public void levelUp(int increase) {
		if (increase < 0)
			return;
		if (this.magicPower + increase > MAX_LEVEL)
			this.magicPower = MAX_LEVEL;
		else
			this.magicPower += increase;
	}
}
